from graph import *

def longPath(G):
    """
    recieves problem specifications,
    starts a path from every node and return the longest
    """
    n = G.dim()
    opt = 0
    for node in range(n):
        P = [node]
        optFromCurrentNode = findBestPath(G,P)
        opt = max(opt,optFromCurrentNode)
    return opt


def findBestPath(G,P):
    """
    the main recursive function.
    Extends Path where possible,
    and returns the maximal length of a FUTURE path
    """
    last = P[-1]
    opt = 0
    validNeighbors = findValidNeighbors(G,P)
    for neighbor in validNeighbors:
        optFromNode = findBestPath(G,P+[neighbor])
        opt = max(opt,G.edges[last, neighbor] + optFromNode)
    return opt


def findValidNeighbors(G,P):
    """
    given a path P, finds all nodes J that can extend P.
    a node J is valid if it a neighbor of I (the
    last node of P), is not higher than I
    and has not yet been traversed (each node can appear
    in P only once).
    """
    n = G.dim()
    i = P[-1]
    candidates = [j for j in range(n) if G.edges[i,j]>0]                # neighbors of I
    candidates = [j for j in candidates if G.nodes[j] <= G.nodes[i]]    # not higher than I
    candidates = [j for j in candidates if j not in P]                  # not yet traversed
    return candidates


# run on example graph
g = Graph.load(r"..\Graph example\g_nodes.txt",r"..\Graph example\g_edges.txt")
print( "longest path in graph: ", longPath(g) )
